package weaverjn.schedule;

package ..deTemp.1731631973248;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.DocumentHelper;
import org.dom4j.Element;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.integration.logging.Logger;
import weaver.integration.logging.LoggerFactory;
import weaver.interfaces.schedule.BaseCronJob;
import weaverjn.util.ModUtil;
import weaverjn.util.WSClientUtils;

public class Updateuf_cbzxbmSchedule extends BaseCronJob {
  private String BUKRS;
  
  public void execute() {
    String BUKRS1 = "";
    BaseBean lg = new BaseBean();
    String ZFILED4 = lg.getPropValue("Updateuf_cbzxbmScheduleProp", "ZFILED4");
    String ZFILED5 = lg.getPropValue("Updateuf_cbzxbmScheduleProp", "ZFILED5");
    String username = lg.getPropValue("Updateuf_cbzxbmScheduleProp", "username");
    String password = lg.getPropValue("Updateuf_cbzxbmScheduleProp", "password");
    String endpoint = lg.getPropValue("Updateuf_cbzxbmScheduleProp", "endpoint");
    String modeid = lg.getPropValue("Updateuf_cbzxbmScheduleProp", "modeid");
    SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
    Date date = new Date();
    String format = sdf.format(date);
    ModUtil md = new ModUtil();
    this.logger.info("ZFILED4...." + ZFILED4);
    this.logger.info("ZFILED5...." + ZFILED5);
    this.logger.info("username...." + username);
    this.logger.info("password...." + password);
    this.logger.info("endpoint...." + endpoint);
    this.logger.info("modeid...." + modeid);
    RecordSet rs = new RecordSet();
    RecordSet rs1 = new RecordSet();
    RecordSet rs2 = new RecordSet();
    RecordSet rs3 = new RecordSet();
    if (!Util.null2String(getBUKRS()).isEmpty())
      BUKRS1 = Util.null2String(getBUKRS()); 
    this.logger.info("BUKRS1...." + ZFILED5);
    String[] split = ZFILED5.split(",");
    for (int j = 0; j < split.length; j++) {
      String xml = "<soapenv:Envelope xmlns:soapenv=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:bpm=\"http://yk.com/oa/bpm\">\n   <soapenv:Header/>\n   <soapenv:Body>\n      <bpm:MT_SSF_REQ>\n         <IS_WFSTATU>\n            <SYSID></SYSID>\n            <IFYWID>FI769</IFYWID>\n            <!--Optional:-->\n            <BSKEY>1</BSKEY>\n            <!--Optional:-->\n            <SAPKEY></SAPKEY>\n            <!--Optional:-->\n            <ZORG></ZORG>\n            <!--Optional:-->\n            <ZFILED1></ZFILED1>\n            <!--Optional:-->\n            <ZFILED2></ZFILED2>\n            <!--Optional:-->\n            <ZFILED3></ZFILED3>\n            <!--Optional:-->\n            <ZFILED4>" + ZFILED4 + "</ZFILED4>\n            <!--Optional:-->\n            <ZFILED5>" + split[j] + "</ZFILED5>\n            <!--Optional:-->\n            <ZDATA>[{\"ZQLBS\":\"X\",\"BUKRS\":\"" + BUKRS1 + "\",\"DPTBM\":\"\",\"ZFILED1\":\"\",\"ZFILED2\":\"\",\"ZFILED3\":\"\"}]</ZDATA>\n         </IS_WFSTATU>\n      </bpm:MT_SSF_REQ>\n   </soapenv:Body>\n</soapenv:Envelope>";
      String str1 = WSClientUtils.callWebServiceSOAP11(xml, endpoint, username, password);
      this.logger.info("str1...." + str1);
      Document doc = null;
      try {
        doc = DocumentHelper.parseText(str1);
      } catch (DocumentException e) {
        e.printStackTrace();
      } 
      Element rootElt = doc.getRootElement();
      Element body1 = rootElt.element("Body");
      Element MT_SSF_RESP = body1.element("MT_SSF_RESP");
      Element es_output = MT_SSF_RESP.element("ES_OUTPUT");
      String ztype = es_output.element("ZTYPE").getText();
      this.logger.info("ztype...." + ztype);
      if (ztype.equals("S")) {
        String ZDATA = es_output.element("ZDATA").getText();
        this.logger.info("ZDATA...." + ZDATA);
        JSONArray objects = JSONArray.parseArray(ZDATA);
        for (int i = 0; i < objects.size(); i++) {
          JSONObject object = objects.getJSONObject(i);
          String MANDT = Util.null2String(object.getString("MANDT"));
          String CCODE = Util.null2String(object.getString("CCODE"));
          String DPTBM = Util.null2String(object.getString("DPTBM"));
          String DPTLX = Util.null2String(object.getString("DPTLX"));
          String KOSTL = Util.null2String(object.getString("KOSTL"));
          String BUKRS = Util.null2String(object.getString("BUKRS"));
          String PRCTR = Util.null2String(object.getString("PRCTR"));
          String ERDAT = Util.null2String(object.getString("ERDAT"));
          String ZSFYX = Util.null2String(object.getString("ZSFYX"));
          String sql1 = "select DESC5 from uf_ZZJG1 where CODE = '" + DPTBM + "'";
          rs2.execute(sql1);
          rs2.next();
          String DESC5 = Util.null2String(rs2.getString("DESC5"));
          String sfwdw = "";
          if (DESC5.equals("02") || DESC5.equals("04")) {
            sfwdw = "否";
          } else {
            sfwdw = "是";
          } 
          String MANDTID = CCODE + "_" + DPTBM + "_" + KOSTL;
          String sql = "select * from uf_cbzxbm where MANDTID = '" + MANDTID + "'";
          this.logger.info("sql...." + sql);
          rs.execute(sql);
          if (rs.next()) {
            String update_sql = "update uf_cbzxbm set xgrq = '" + format + "',MANDT = '" + MANDT + "',BUKRS = '" + BUKRS + "',CCODE = '" + CCODE + "',DPTLX = '" + DPTLX + "',ERDAT = '" + ERDAT + "',ZSFYX = '" + ZSFYX + "',sfwdw = '" + sfwdw + "' where MANDTID = '" + MANDTID + "'";
            this.logger.info("update_sql...." + update_sql);
            rs1.execute(update_sql);
          } else {
            Map<String, String> map = new HashMap<>();
            map.put("MANDT", MANDT);
            map.put("BUKRS", BUKRS);
            map.put("CCODE", CCODE);
            map.put("DPTLX", DPTLX);
            map.put("DPTBM", DPTBM);
            map.put("ERDAT", ERDAT);
            map.put("ZSFYX", ZSFYX);
            map.put("sfwdw", sfwdw);
            map.put("xgrq", format);
            map.put("ZSFYX", "1");
            map.put("MANDTID", MANDTID);
            int sun = md.addData(map, Util.getIntValue(modeid), 1);
            this.logger.info("sun...." + sun);
          } 
        } 
        String updatesql = "update uf_cbzxbm set ZSFYX = '0' where (xgrq <>'" + format + "' or xgrq is null)";
        rs3.execute(updatesql);
        this.logger.info("updatesql...." + updatesql);
      } 
    } 
  }
  
  public String getBUKRS() {
    return this.BUKRS;
  }
  
  public void setBUKRS(String BUKRS) {
    this.BUKRS = BUKRS;
  }
  
  private final Logger logger = LoggerFactory.getLogger(getClass());
}
